package com.xxl.job.admin.core.route;

package .tmp;

import com.xxl.job.admin.core.route.ExecutorRouter;
import com.xxl.job.admin.core.route.strategy.ExecutorRouteBusyover;
import com.xxl.job.admin.core.route.strategy.ExecutorRouteConsistentHash;
import com.xxl.job.admin.core.route.strategy.ExecutorRouteFailover;
import com.xxl.job.admin.core.route.strategy.ExecutorRouteFirst;
import com.xxl.job.admin.core.route.strategy.ExecutorRouteLFU;
import com.xxl.job.admin.core.route.strategy.ExecutorRouteLRU;
import com.xxl.job.admin.core.route.strategy.ExecutorRouteLast;
import com.xxl.job.admin.core.route.strategy.ExecutorRouteRandom;
import com.xxl.job.admin.core.route.strategy.ExecutorRouteRound;
import com.xxl.job.admin.core.util.I18nUtil;

public enum ExecutorRouteStrategyEnum {
  FIRST(I18nUtil.getString("jobconf_route_first"), (ExecutorRouter)new ExecutorRouteFirst()),
  LAST(I18nUtil.getString("jobconf_route_last"), (ExecutorRouter)new ExecutorRouteLast()),
  ROUND(I18nUtil.getString("jobconf_route_round"), (ExecutorRouter)new ExecutorRouteRound()),
  RANDOM(I18nUtil.getString("jobconf_route_random"), (ExecutorRouter)new ExecutorRouteRandom()),
  CONSISTENT_HASH(I18nUtil.getString("jobconf_route_consistenthash"), (ExecutorRouter)new ExecutorRouteConsistentHash()),
  LEAST_FREQUENTLY_USED(I18nUtil.getString("jobconf_route_lfu"), (ExecutorRouter)new ExecutorRouteLFU()),
  LEAST_RECENTLY_USED(I18nUtil.getString("jobconf_route_lru"), (ExecutorRouter)new ExecutorRouteLRU()),
  FAILOVER(I18nUtil.getString("jobconf_route_failover"), (ExecutorRouter)new ExecutorRouteFailover()),
  BUSYOVER(I18nUtil.getString("jobconf_route_busyover"), (ExecutorRouter)new ExecutorRouteBusyover()),
  SHARDING_BROADCAST(I18nUtil.getString("jobconf_route_shard"), null);
  
  private String title;
  
  private ExecutorRouter router;
  
  ExecutorRouteStrategyEnum(String title, ExecutorRouter router) {
    this.title = title;
    this.router = router;
  }
  
  public String getTitle() {
    return this.title;
  }
  
  public ExecutorRouter getRouter() {
    return this.router;
  }
  
  public static com.xxl.job.admin.core.route.ExecutorRouteStrategyEnum match(String name, com.xxl.job.admin.core.route.ExecutorRouteStrategyEnum defaultItem) {
    if (name != null)
      for (com.xxl.job.admin.core.route.ExecutorRouteStrategyEnum item : values()) {
        if (item.name().equals(name))
          return item; 
      }  
    return defaultItem;
  }
}
